<?php

namespace App\Delivery\Dhl\EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for RequestBarcodeInfo EnumType
 * Meta information extracted from the WSDL
 * - documentation: Additional response fields including waybill number, license plate(s) for each piece(s), origin destination service area code, DHL routing and Client ID barcode in base64 image format to be returned in the Create Shipment response
 * @subpackage Enumerations
 */
class RequestBarcodeInfo extends AbstractStructEnumBase
{
    /**
     * Constant for value 'Y'
     * @return string 'Y'
     */
    const VALUE_Y = 'Y';
    /**
     * Constant for value 'N'
     * @return string 'N'
     */
    const VALUE_N = 'N';
    /**
     * Return allowed values
     * @uses self::VALUE_Y
     * @uses self::VALUE_N
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_Y,
            self::VALUE_N,
        );
    }
}
