<?php

namespace App\Delivery\Dhl\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomerDataTextEntries StructType
 * Meta information extracted from the WSDL
 * - documentation: Customer Data Texts that would like to be printed in COMMERCIAL_INVOICE_04 template (note: only to be used for preparing Loose BBX shipments)
 * @subpackage Structs
 */
class CustomerDataTextEntries extends AbstractStructBase
{
    /**
     * The CustomerDataTextEntry
     * Meta information extracted from the WSDL
     * - documentation: Customer Data Texts that would like to be printed in COMMERCIAL_INVOICE_04 template
     * - minOccurs: 0
     * @var \App\Delivery\Dhl\StructType\CustomerDataTextEntry
     */
    public $CustomerDataTextEntry;
    /**
     * Constructor method for CustomerDataTextEntries
     * @uses CustomerDataTextEntries::setCustomerDataTextEntry()
     * @param \App\Delivery\Dhl\StructType\CustomerDataTextEntry $customerDataTextEntry
     */
    public function __construct(\App\Delivery\Dhl\StructType\CustomerDataTextEntry $customerDataTextEntry = null)
    {
        $this
            ->setCustomerDataTextEntry($customerDataTextEntry);
    }
    /**
     * Get CustomerDataTextEntry value
     * @return \App\Delivery\Dhl\StructType\CustomerDataTextEntry|null
     */
    public function getCustomerDataTextEntry()
    {
        return $this->CustomerDataTextEntry;
    }
    /**
     * Set CustomerDataTextEntry value
     * @param \App\Delivery\Dhl\StructType\CustomerDataTextEntry $customerDataTextEntry
     * @return \App\Delivery\Dhl\StructType\CustomerDataTextEntries
     */
    public function setCustomerDataTextEntry(\App\Delivery\Dhl\StructType\CustomerDataTextEntry $customerDataTextEntry = null)
    {
        $this->CustomerDataTextEntry = $customerDataTextEntry;
        return $this;
    }
}
