<?php

namespace App\Delivery\Dhl\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for docTypeRef_ExchangeRateType StructType
 * @subpackage Structs
 */
class DocTypeRef_ExchangeRateType extends AbstractStructBase
{
    /**
     * The ExchangeRate
     * Meta information extracted from the WSDL
     * - maxOccurs: 3
     * @var \App\Delivery\Dhl\StructType\ExchangeRate[]
     */
    public $ExchangeRate;
    /**
     * Constructor method for docTypeRef_ExchangeRateType
     * @uses DocTypeRef_ExchangeRateType::setExchangeRate()
     * @param \App\Delivery\Dhl\StructType\ExchangeRate[] $exchangeRate
     */
    public function __construct(array $exchangeRate = array())
    {
        $this
            ->setExchangeRate($exchangeRate);
    }
    /**
     * Get ExchangeRate value
     * @return \App\Delivery\Dhl\StructType\ExchangeRate[]|null
     */
    public function getExchangeRate()
    {
        return $this->ExchangeRate;
    }
    /**
     * This method is responsible for validating the values passed to the setExchangeRate method
     * This method is willingly generated in order to preserve the one-line inline validation within the setExchangeRate method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateExchangeRateForArrayConstraintsFromSetExchangeRate(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $docTypeRef_ExchangeRateTypeExchangeRateItem) {
            // validation for constraint: itemType
            if (!$docTypeRef_ExchangeRateTypeExchangeRateItem instanceof \App\Delivery\Dhl\StructType\ExchangeRate) {
                $invalidValues[] = is_object($docTypeRef_ExchangeRateTypeExchangeRateItem) ? get_class($docTypeRef_ExchangeRateTypeExchangeRateItem) : sprintf('%s(%s)', gettype($docTypeRef_ExchangeRateTypeExchangeRateItem), var_export($docTypeRef_ExchangeRateTypeExchangeRateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ExchangeRate property can only contain items of type \App\Delivery\Dhl\StructType\ExchangeRate, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ExchangeRate value
     * @throws \InvalidArgumentException
     * @param \App\Delivery\Dhl\StructType\ExchangeRate[] $exchangeRate
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_ExchangeRateType
     */
    public function setExchangeRate(array $exchangeRate = array())
    {
        // validation for constraint: array
        if ('' !== ($exchangeRateArrayErrorMessage = self::validateExchangeRateForArrayConstraintsFromSetExchangeRate($exchangeRate))) {
            throw new \InvalidArgumentException($exchangeRateArrayErrorMessage, __LINE__);
        }
        // validation for constraint: maxOccurs(3)
        if (is_array($exchangeRate) && count($exchangeRate) > 3) {
            throw new \InvalidArgumentException(sprintf('Invalid count of %s, the number of elements contained by the property must be less than or equal to 3', count($exchangeRate)), __LINE__);
        }
        $this->ExchangeRate = $exchangeRate;
        return $this;
    }
    /**
     * Add item to ExchangeRate value
     * @throws \InvalidArgumentException
     * @param \App\Delivery\Dhl\StructType\ExchangeRate $item
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_ExchangeRateType
     */
    public function addToExchangeRate(\App\Delivery\Dhl\StructType\ExchangeRate $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App\Delivery\Dhl\StructType\ExchangeRate) {
            throw new \InvalidArgumentException(sprintf('The ExchangeRate property can only contain items of type \App\Delivery\Dhl\StructType\ExchangeRate, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        // validation for constraint: maxOccurs(3)
        if (is_array($this->ExchangeRate) && count($this->ExchangeRate) >= 3) {
            throw new \InvalidArgumentException(sprintf('You can\'t add anymore element to this property that already contains %s elements, the number of elements contained by the property must be less than or equal to 3', count($this->ExchangeRate)), __LINE__);
        }
        $this->ExchangeRate[] = $item;
        return $this;
    }
}
