<?php

namespace App\Delivery\Dhl\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for docTypeRef_NotificationType3 StructType
 * @subpackage Structs
 */
class DocTypeRef_NotificationType3 extends AbstractStructBase
{
    /**
     * The Message
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - whiteSpace: collapse
     * @var string
     */
    public $Message;
    /**
     * The code
     * Meta information extracted from the WSDL
     * - documentation: Notification code: valid values are 0=SUCCESS, other value=ERROR
     * - base: xsd:token
     * - whiteSpace: collapse
     * @var string
     */
    public $code;
    /**
     * The src
     * Meta information extracted from the WSDL
     * - base: xsd:token
     * - use: optional
     * - whiteSpace: collapse
     * @var string
     */
    public $src;
    /**
     * Constructor method for docTypeRef_NotificationType3
     * @uses DocTypeRef_NotificationType3::setMessage()
     * @uses DocTypeRef_NotificationType3::setCode()
     * @uses DocTypeRef_NotificationType3::setSrc()
     * @param string $message
     * @param string $code
     * @param string $src
     */
    public function __construct($message = null, $code = null, $src = null)
    {
        $this
            ->setMessage($message)
            ->setCode($code)
            ->setSrc($src);
    }
    /**
     * Get Message value
     * @return string|null
     */
    public function getMessage()
    {
        return $this->Message;
    }
    /**
     * Set Message value
     * @param string $message
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_NotificationType3
     */
    public function setMessage($message = null)
    {
        // validation for constraint: string
        if (!is_null($message) && !is_string($message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($message, true), gettype($message)), __LINE__);
        }
        $this->Message = $message;
        return $this;
    }
    /**
     * Get code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->code;
    }
    /**
     * Set code value
     * @param string $code
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_NotificationType3
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($code, true), gettype($code)), __LINE__);
        }
        $this->code = $code;
        return $this;
    }
    /**
     * Get src value
     * @return string|null
     */
    public function getSrc()
    {
        return $this->src;
    }
    /**
     * Set src value
     * @param string $src
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_NotificationType3
     */
    public function setSrc($src = null)
    {
        // validation for constraint: string
        if (!is_null($src) && !is_string($src)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($src, true), gettype($src)), __LINE__);
        }
        $this->src = $src;
        return $this;
    }
}
