<?php

namespace App\Delivery\Dhl\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for docTypeRef_RateRequestType StructType
 * @subpackage Structs
 */
class DocTypeRef_RateRequestType extends AbstractStructBase
{
    /**
     * The ClientDetail
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \App\Delivery\Dhl\StructType\DocTypeRef_ClientDetailType3
     */
    public $ClientDetail;
    /**
     * The Request
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \App\Delivery\Dhl\StructType\RequestType
     */
    public $Request;
    /**
     * The RequestedShipment
     * @var \App\Delivery\Dhl\StructType\DocTypeRef_RequestedShipmentType2
     */
    public $RequestedShipment;
    /**
     * Constructor method for docTypeRef_RateRequestType
     * @uses DocTypeRef_RateRequestType::setClientDetail()
     * @uses DocTypeRef_RateRequestType::setRequest()
     * @uses DocTypeRef_RateRequestType::setRequestedShipment()
     * @param \App\Delivery\Dhl\StructType\DocTypeRef_ClientDetailType3 $clientDetail
     * @param \App\Delivery\Dhl\StructType\RequestType $request
     * @param \App\Delivery\Dhl\StructType\DocTypeRef_RequestedShipmentType2 $requestedShipment
     */
    public function __construct(\App\Delivery\Dhl\StructType\DocTypeRef_ClientDetailType3 $clientDetail = null, \App\Delivery\Dhl\StructType\RequestType $request = null, \App\Delivery\Dhl\StructType\DocTypeRef_RequestedShipmentType2 $requestedShipment = null)
    {
        $this
            ->setClientDetail($clientDetail)
            ->setRequest($request)
            ->setRequestedShipment($requestedShipment);
    }
    /**
     * Get ClientDetail value
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_ClientDetailType3|null
     */
    public function getClientDetail()
    {
        return $this->ClientDetail;
    }
    /**
     * Set ClientDetail value
     * @param \App\Delivery\Dhl\StructType\DocTypeRef_ClientDetailType3 $clientDetail
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_RateRequestType
     */
    public function setClientDetail(\App\Delivery\Dhl\StructType\DocTypeRef_ClientDetailType3 $clientDetail = null)
    {
        $this->ClientDetail = $clientDetail;
        return $this;
    }
    /**
     * Get Request value
     * @return \App\Delivery\Dhl\StructType\RequestType|null
     */
    public function getRequest()
    {
        return $this->Request;
    }
    /**
     * Set Request value
     * @param \App\Delivery\Dhl\StructType\RequestType $request
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_RateRequestType
     */
    public function setRequest(\App\Delivery\Dhl\StructType\RequestType $request = null)
    {
        $this->Request = $request;
        return $this;
    }
    /**
     * Get RequestedShipment value
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_RequestedShipmentType2|null
     */
    public function getRequestedShipment()
    {
        return $this->RequestedShipment;
    }
    /**
     * Set RequestedShipment value
     * @param \App\Delivery\Dhl\StructType\DocTypeRef_RequestedShipmentType2 $requestedShipment
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_RateRequestType
     */
    public function setRequestedShipment(\App\Delivery\Dhl\StructType\DocTypeRef_RequestedShipmentType2 $requestedShipment = null)
    {
        $this->RequestedShipment = $requestedShipment;
        return $this;
    }
}
