<?php

namespace App\Delivery\Dhl\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for docTypeRef_TotalNet StructType
 * @subpackage Structs
 */
class DocTypeRef_TotalNet extends AbstractStructBase
{
    /**
     * The type
     * Meta information extracted from the WSDL
     * - use: required
     * @var string
     */
    public $type;
    /**
     * The Currency
     * Meta information extracted from the WSDL
     * - documentation: Total shipping charge with tax
     * @var string
     */
    public $Currency;
    /**
     * The Amount
     * Meta information extracted from the WSDL
     * - documentation: PackageCharge or the Weight Charge
     * @var string
     */
    public $Amount;
    /**
     * The Charges
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \App\Delivery\Dhl\StructType\DocTypeRef_Charges
     */
    public $Charges;
    /**
     * Constructor method for docTypeRef_TotalNet
     * @uses DocTypeRef_TotalNet::setType()
     * @uses DocTypeRef_TotalNet::setCurrency()
     * @uses DocTypeRef_TotalNet::setAmount()
     * @uses DocTypeRef_TotalNet::setCharges()
     * @param string $type
     * @param string $currency
     * @param string $amount
     * @param \App\Delivery\Dhl\StructType\DocTypeRef_Charges $charges
     */
    public function __construct($type = null, $currency = null, $amount = null, \App\Delivery\Dhl\StructType\DocTypeRef_Charges $charges = null)
    {
        $this
            ->setType($type)
            ->setCurrency($currency)
            ->setAmount($amount)
            ->setCharges($charges);
    }
    /**
     * Get type value
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param string $type
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_TotalNet
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Get Currency value
     * @return string|null
     */
    public function getCurrency()
    {
        return $this->Currency;
    }
    /**
     * Set Currency value
     * @param string $currency
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_TotalNet
     */
    public function setCurrency($currency = null)
    {
        // validation for constraint: string
        if (!is_null($currency) && !is_string($currency)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($currency, true), gettype($currency)), __LINE__);
        }
        $this->Currency = $currency;
        return $this;
    }
    /**
     * Get Amount value
     * @return string|null
     */
    public function getAmount()
    {
        return $this->Amount;
    }
    /**
     * Set Amount value
     * @param string $amount
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_TotalNet
     */
    public function setAmount($amount = null)
    {
        // validation for constraint: string
        if (!is_null($amount) && !is_string($amount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($amount, true), gettype($amount)), __LINE__);
        }
        $this->Amount = $amount;
        return $this;
    }
    /**
     * Get Charges value
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_Charges|null
     */
    public function getCharges()
    {
        return $this->Charges;
    }
    /**
     * Set Charges value
     * @param \App\Delivery\Dhl\StructType\DocTypeRef_Charges $charges
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_TotalNet
     */
    public function setCharges(\App\Delivery\Dhl\StructType\DocTypeRef_Charges $charges = null)
    {
        $this->Charges = $charges;
        return $this;
    }
}
