<?php

namespace App\Delivery\Dhl\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for docTypeRef_TrackingNumberBarcodes StructType
 * @subpackage Structs
 */
class DocTypeRef_TrackingNumberBarcodes extends AbstractStructBase
{
    /**
     * The TrackingNumberBarcode
     * Meta information extracted from the WSDL
     * - maxOccurs: 999
     * @var \App\Delivery\Dhl\StructType\DocTypeRef_TrackingNumberBarcode[]
     */
    public $TrackingNumberBarcode;
    /**
     * Constructor method for docTypeRef_TrackingNumberBarcodes
     * @uses DocTypeRef_TrackingNumberBarcodes::setTrackingNumberBarcode()
     * @param \App\Delivery\Dhl\StructType\DocTypeRef_TrackingNumberBarcode[] $trackingNumberBarcode
     */
    public function __construct(array $trackingNumberBarcode = array())
    {
        $this
            ->setTrackingNumberBarcode($trackingNumberBarcode);
    }
    /**
     * Get TrackingNumberBarcode value
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_TrackingNumberBarcode[]|null
     */
    public function getTrackingNumberBarcode()
    {
        return $this->TrackingNumberBarcode;
    }
    /**
     * This method is responsible for validating the values passed to the setTrackingNumberBarcode method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTrackingNumberBarcode method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTrackingNumberBarcodeForArrayConstraintsFromSetTrackingNumberBarcode(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $docTypeRef_TrackingNumberBarcodesTrackingNumberBarcodeItem) {
            // validation for constraint: itemType
            if (!$docTypeRef_TrackingNumberBarcodesTrackingNumberBarcodeItem instanceof \App\Delivery\Dhl\StructType\DocTypeRef_TrackingNumberBarcode) {
                $invalidValues[] = is_object($docTypeRef_TrackingNumberBarcodesTrackingNumberBarcodeItem) ? get_class($docTypeRef_TrackingNumberBarcodesTrackingNumberBarcodeItem) : sprintf('%s(%s)', gettype($docTypeRef_TrackingNumberBarcodesTrackingNumberBarcodeItem), var_export($docTypeRef_TrackingNumberBarcodesTrackingNumberBarcodeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TrackingNumberBarcode property can only contain items of type \App\Delivery\Dhl\StructType\DocTypeRef_TrackingNumberBarcode, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TrackingNumberBarcode value
     * @throws \InvalidArgumentException
     * @param \App\Delivery\Dhl\StructType\DocTypeRef_TrackingNumberBarcode[] $trackingNumberBarcode
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_TrackingNumberBarcodes
     */
    public function setTrackingNumberBarcode(array $trackingNumberBarcode = array())
    {
        // validation for constraint: array
        if ('' !== ($trackingNumberBarcodeArrayErrorMessage = self::validateTrackingNumberBarcodeForArrayConstraintsFromSetTrackingNumberBarcode($trackingNumberBarcode))) {
            throw new \InvalidArgumentException($trackingNumberBarcodeArrayErrorMessage, __LINE__);
        }
        // validation for constraint: maxOccurs(999)
        if (is_array($trackingNumberBarcode) && count($trackingNumberBarcode) > 999) {
            throw new \InvalidArgumentException(sprintf('Invalid count of %s, the number of elements contained by the property must be less than or equal to 999', count($trackingNumberBarcode)), __LINE__);
        }
        $this->TrackingNumberBarcode = $trackingNumberBarcode;
        return $this;
    }
    /**
     * Add item to TrackingNumberBarcode value
     * @throws \InvalidArgumentException
     * @param \App\Delivery\Dhl\StructType\DocTypeRef_TrackingNumberBarcode $item
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_TrackingNumberBarcodes
     */
    public function addToTrackingNumberBarcode(\App\Delivery\Dhl\StructType\DocTypeRef_TrackingNumberBarcode $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App\Delivery\Dhl\StructType\DocTypeRef_TrackingNumberBarcode) {
            throw new \InvalidArgumentException(sprintf('The TrackingNumberBarcode property can only contain items of type \App\Delivery\Dhl\StructType\DocTypeRef_TrackingNumberBarcode, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        // validation for constraint: maxOccurs(999)
        if (is_array($this->TrackingNumberBarcode) && count($this->TrackingNumberBarcode) >= 999) {
            throw new \InvalidArgumentException(sprintf('You can\'t add anymore element to this property that already contains %s elements, the number of elements contained by the property must be less than or equal to 999', count($this->TrackingNumberBarcode)), __LINE__);
        }
        $this->TrackingNumberBarcode[] = $item;
        return $this;
    }
}
