<?php

namespace App\Delivery\Dhl\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ServiceHandlingFeatureCodes StructType
 * Meta information extracted from the WSDL
 * - documentation: Service handling feature codes returned from Document Rendering service
 * - type: s3:ServiceHandlingFeatureCodes
 * @subpackage Structs
 */
class ServiceHandlingFeatureCodes extends AbstractStructBase
{
    /**
     * The ServiceHandlingFeatureCode
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - minOccurs: 0
     * @var string
     */
    public $ServiceHandlingFeatureCode;
    /**
     * Constructor method for ServiceHandlingFeatureCodes
     * @uses ServiceHandlingFeatureCodes::setServiceHandlingFeatureCode()
     * @param string $serviceHandlingFeatureCode
     */
    public function __construct($serviceHandlingFeatureCode = null)
    {
        $this
            ->setServiceHandlingFeatureCode($serviceHandlingFeatureCode);
    }
    /**
     * Get ServiceHandlingFeatureCode value
     * @return string|null
     */
    public function getServiceHandlingFeatureCode()
    {
        return $this->ServiceHandlingFeatureCode;
    }
    /**
     * Set ServiceHandlingFeatureCode value
     * @param string $serviceHandlingFeatureCode
     * @return \App\Delivery\Dhl\StructType\ServiceHandlingFeatureCodes
     */
    public function setServiceHandlingFeatureCode($serviceHandlingFeatureCode = null)
    {
        // validation for constraint: string
        if (!is_null($serviceHandlingFeatureCode) && !is_string($serviceHandlingFeatureCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($serviceHandlingFeatureCode, true), gettype($serviceHandlingFeatureCode)), __LINE__);
        }
        $this->ServiceHandlingFeatureCode = $serviceHandlingFeatureCode;
        return $this;
    }
}
