<?php

namespace App\Delivery\Dhl\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ShipmentReferences StructType
 * Meta information extracted from the WSDL
 * - documentation: Customer bar code that would like to be printed in supported transport label - ECOM26_84CI_003 templates
 * @subpackage Structs
 */
class ShipmentReferences extends AbstractStructBase
{
    /**
     * The ShipmentReference
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \App\Delivery\Dhl\StructType\ShipmentReferenceType
     */
    public $ShipmentReference;
    /**
     * Constructor method for ShipmentReferences
     * @uses ShipmentReferences::setShipmentReference()
     * @param \App\Delivery\Dhl\StructType\ShipmentReferenceType $shipmentReference
     */
    public function __construct(\App\Delivery\Dhl\StructType\ShipmentReferenceType $shipmentReference = null)
    {
        $this
            ->setShipmentReference($shipmentReference);
    }
    /**
     * Get ShipmentReference value
     * @return \App\Delivery\Dhl\StructType\ShipmentReferenceType|null
     */
    public function getShipmentReference()
    {
        return $this->ShipmentReference;
    }
    /**
     * Set ShipmentReference value
     * @param \App\Delivery\Dhl\StructType\ShipmentReferenceType $shipmentReference
     * @return \App\Delivery\Dhl\StructType\ShipmentReferences
     */
    public function setShipmentReference(\App\Delivery\Dhl\StructType\ShipmentReferenceType $shipmentReference = null)
    {
        $this->ShipmentReference = $shipmentReference;
        return $this;
    }
}
